* 'AutoAdjust (c) 2007-2010 MigSoft


*-----------------------------------------------------------------------------*

PROCEDURE AutoAdjust( cForm )

   LOCAL hWnd := GetFormHandle( cForm )
   
   LOCAL i,;                    // From no
         k,;                    // Control no                  
         ParentForm,;  
         ControlCount,; 
         ControlName,; 
         ControlType,; 
         nWidth,; 
         nHeight,; 
         lvisible := .T.,; 
         nDivw,; 
         nDivh
         
   IF GetDesktopWidth() < GetWindowWidth ( hWnd )
      nWidth := GetDesktopWidth()
   ELSE
      nWidth := GetWindowWidth ( hWnd )
   ENDIF

   IF GetDesktopHeight() < GetWindowHeight ( hWnd )
      nHeight := GetDesktopHeight()
   ELSE
      nHeight := GetWindowHeight( hWnd )
   ENDIF

   IF IsWindowVisible( hWnd ) .AND. ! IsAppXPThemed()
      HideWindow ( hWnd )
   ELSE
      lvisible := .F.
   ENDIF

   i := aScan ( _HMG_SYSDATA[67], hWnd )
   
   ParentForm := _HMG_SYSDATA[66] [i]

   IF _HMG_SYSDATA[ 92, i ] > 0 .AND. _HMG_SYSDATA[ 91, i ] > 0
      nDivw := nWidth  / _HMG_SYSDATA[ 92, i]
      nDivh := nHeight / _HMG_SYSDATA[ 91, i]
   ELSE
      nDivw := 1
      nDivh := 1
   ENDIF

   ControlCount := LEN ( _HMG_SYSDATA[ 3 ] )

   FOR k := 1 To ControlCount

      ControlName := _HMG_SYSDATA[ 2, k ]

      IF _IsControlDefined ( ControlName, ParentForm )

         ControlType := _HMG_SYSDATA[ 1, k ]

         IF !EMPTY( ControlName ) .AND. !( ControlType $ "MENU,HOTKEY,TOOLBAR,MESSAGEBAR,ITEMMESSAGE,TIMER" ) 
         
            //.AND.;
            //Empty( GetControlContainerHandle ( ControlName, ParentForm ) )

            IF ControlType == 'RADIOGROUP'
               _HMG_aControlSpacing     := _HMG_SYSDATA[ 22 ] // BE: D320
               _HMG_aControlMiscData1   := _HMG_SYSDATA[  8 ] //  "    "
               _HMG_aControlSpacing [k] := _HMG_aControlSpacing [k] * ;
                    IF(_HMG_aControlMiscData1 [k], nDivw, nDivh)
            ENDIF

            IF ControlType # 'STATUSBAR' .AND. ControlType # 'TOOLBUTTON'
            _SetControlSizePos ( ControlName, ParentForm,;
               _GetControlRow ( ControlName, ParentForm ) ;
               * nDivh, _GetControlCol ( ControlName, ParentForm ) * nDivw,;
               _GetControlWidth ( ControlName, ParentForm ) * ;
               nDivw, _GetControlHeight ( ControlName, ParentForm ) * nDivh )
            ENDIF
            
            IF ControlType <> 'SLIDER'
		         IF EMPTY(_HMG_SYSDATA[28, k] )
    		         _SetFontSize ( ControlName, ParentForm , 8 * nDivh )
  		         ELSE
     		         _SetFontSize ( ControlName, ParentForm , _HMG_SYSDATA[28] [k] * nDivh )
  		         ENDIF

            ENDIF

         ENDIF

      ENDIF

   NEXT k

   _HMG_SYSDATA[92]  [i] := nWidth
   _HMG_SYSDATA[91] [i]  := nHeight

   IF lvisible
      ShowWindow ( hWnd )
   ENDIF

RETURN // AutoAdjust() 

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

FUNCTION ISAPPXPTHEMED()
RETURN ( OS_ISWINXP_OR_LATER() ;     // <= hrb\contrib/hbwin/legacycv.c
         .AND. IsAppThemed() )       // <= HMG\h_window.prg       

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._

